Page MenuHomePhabricator

Make PayPal IPN verification retry a few times
Closed, ResolvedPublic2 Story Points

Description

Best guess is a back-end round robin where most of the servers usually work. For the last 5 days we have been getting a lot of failures. Retrying them might help.

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptNov 15 2016, 5:21 PM
cwdent moved this task from Backlog to Doing on the Fundraising Sprint Value Subtracting board.
cwdent set the point value for this task to 2.
K4-713 added a subscriber: K4-713.Nov 15 2016, 11:09 PM

I have done some archaeology in my own old inbox, and here are some things that I found which should help track down what we did back in 2012 to fix what sounds like an identical issue we had back then:

  • There are probably actually two things going on. The first is that we are expected to retry until one works. The old listener did in fact include a pause between retries, of 250,000 microseconds (better known as 1/4 second).
  • There is a second issue going on, in which instead of a VERIFIED or INVALID, you receive an entire webpage. This was much more difficult to solve.
    • The patch to fix this issue with the old listener was committed at some point between 10/4 and 10/24/2012, probably by user "pgehres". If you have access to the old repo, you should be able to find what we did right around that date.
    • Whatever we did, it had something to do with encoding the response, and according to my emails I clearly didn't think it was going to solve the problem. I was wrong.
  • I still suspect that they have something fishy in their server pool. But the fact that it's been broken for exactly this way for at least four years, makes me think they have no interest or reason to fix the thing.

If you want original emails, which are long and weird and probably very very funny, I can send the best ones to fr-tech members.

Change 321839 had a related patch set uploaded (by Cdentinger):
Try to validate IPN message 7 times.

https://gerrit.wikimedia.org/r/321839

Change 321839 merged by jenkins-bot:
Try to validate IPN message 7 times.

https://gerrit.wikimedia.org/r/321839

cwdent closed this task as Resolved.Nov 16 2016, 11:42 PM

Well the errors conveniently stopped happening but if they start up again this should fix 'em